%global base_name  jci
%global short_name commons-%{base_name}
%global namedreltag -SNAPSHOT
%global namedversion %{version}%{?namedreltag}
%define with_maven 1

Name:          apache-commons-jci
Version:       1.1
Release:       %mkrel 1
Summary:       Commons Java Compiler Interface
Group:         Development/Java
License:       ASL 2.0
Url:           http://commons.apache.org/jci/
# svn export http://svn.apache.org/repos/asf/commons/proper/jci/trunk/  commons-jci-1.1-SNAPSHOT
# tar czf commons-jci-1.1-SNAPSHOT-src-svn.tar.gz commons-jci-1.1-SNAPSHOT
Source0:       commons-jci-1.1-SNAPSHOT-src-svn.tar.gz
Source1:       commons-jci-1.1-depmap
Source2:       commons-jci-1.1-SNAPSHOT-autogeneratedfiles.tar.gz
Patch0:        apache-commons-jci-1.1-add-fam-module.patch
Patch1:        apache-commons-jci-1.1-add-examples-module.patch
Patch2:        apache-commons-jci-1.1-add-javac-module.patch
Patch3:        apache-commons-jci-1.1-module-javac-pom.patch
Patch4:        apache-commons-jci-1.1-JavacClassLoader.patch
BuildRequires: jpackage-utils
BuildRequires: java-devel

BuildRequires: apache-commons-io
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: ecj3
BuildRequires: groovy
BuildRequires: janino
BuildRequires: junit
BuildRequires: objectweb-asm
BuildRequires: rhino
BuildRequires: servletapi5

# javac module
BuildRequires: asm2
BuildRequires: vafer-dependency

%if !%with_maven
BuildRequires: ant
%else
BuildRequires: findbugs-maven-plugin
BuildRequires: jetty-maven-plugins
BuildRequires: maven
BuildRequires: maven-assembly-plugin
BuildRequires: maven-gpg-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-plugin-jxr
BuildRequires: maven-pmd-plugin
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-release-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-report-plugin
BuildRequires: maven-wagon
BuildRequires: taglist-maven-plugin
BuildRequires: maven-ant-plugin
%endif

Requires:      apache-commons-io
Requires:      apache-commons-lang
Requires:      apache-commons-logging
Requires:      ecj3
Requires:      groovy
Requires:      janino
Requires:      junit
Requires:      objectweb-asm
Requires:      rhino
Requires:      servletapi5
# javac module
Requires:      asm2
Requires:      vafer-dependency

Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
JCI is a java compiler interface featuring a compiling classloader.
The current implementation supports compilation via the following
compilers:

* eclipse
* janino
* javac
* groovy (1.7.x)
* rhino

%package javadoc
Summary:       API documentation for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains Maven plugin for %{name}

%prep
%setup -q -n %{short_name}-%{namedversion}

for j in $(find . -name "*.jar"  -o -name '*.class' ); do
  rm -rf $j
done

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p1
%if !%with_maven
tar xf %{SOURCE2}
%endif

%build
%if %with_maven
mvn-rpmbuild -e \
  -Dmaven.local.depmap.file=%{SOURCE1} \
  -Dmaven.test.failure.ignore=true \
  ant:ant install  javadoc:aggregate
%else
# TODO
%endif
%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}

install -pm 644 fam/target/%{short_name}-fam-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-fam-%{version}.jar

install -pm 644 core/target/%{short_name}-core-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-core-%{version}.jar
install -pm 644 core/target/%{short_name}-core-%{namedversion}-tests.jar \
  %{buildroot}%{_javadir}/%{name}-core-tests-%{version}.jar

install -m 644 compilers/javac/target/%{short_name}-javac-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-javac-%{version}.jar

install -m 644 compilers/eclipse/target/%{short_name}-eclipse-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-eclipse-%{version}.jar

install -m 644 compilers/groovy/target/%{short_name}-groovy-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-groovy-%{version}.jar

install -m 644 compilers/janino/target/%{short_name}-janino-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-janino-%{version}.jar

install -m 644 compilers/rhino/target/%{short_name}-rhino-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-rhino-%{version}.jar

install -m 644 examples/target/%{short_name}-examples-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-examples-%{version}.jar

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}.jar; do
    ln -sf ${jar} `echo $jar| sed "s|apache-||g"`
  done
)

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}.jar; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%add_to_maven_depmap org.apache.commons %{short_name} %{version} JPP %{short_name}
install -pm 644 fam/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-fam.pom
%add_to_maven_depmap org.apache.commons %{short_name}-fam %{version} JPP %{short_name}-fam
install -pm 644 core/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-core.pom
%add_to_maven_depmap org.apache.commons %{short_name}-core %{version} JPP %{short_name}-core
install -m 644 compilers/javac/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-javac.pom
%add_to_maven_depmap org.apache.commons %{short_name}-javac %{version} JPP %{short_name}-javac
install -m 644 compilers/eclipse/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-eclipse.pom
%add_to_maven_depmap org.apache.commons %{short_name}-eclipse %{version} JPP %{short_name}-eclipse
install -m 644 compilers/groovy/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-groovy.pom
%add_to_maven_depmap org.apache.commons %{short_name}-groovy %{version} JPP %{short_name}-groovy
install -m 644 compilers/janino/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-janino.pom
%add_to_maven_depmap org.apache.commons %{short_name}-janino %{version} JPP %{short_name}-janino
install -m 644 compilers/rhino/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-rhino.pom
%add_to_maven_depmap org.apache.commons %{short_name}-rhino %{version} JPP %{short_name}-rhino
install -pm 644 examples/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-examples.pom
%add_to_maven_depmap org.apache.commons %{short_name}-examples %{version} JPP %{short_name}-examples


mkdir -p %{buildroot}%{_javadocdir}/%{short_name}
cp -pr  target/site/apidocs/* %{buildroot}%{_javadocdir}/%{short_name}

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/%{name}-fam-%{version}.jar
%{_javadir}/%{name}-fam.jar
%{_javadir}/%{name}-core-%{version}.jar
%{_javadir}/%{name}-core.jar
%{_javadir}/%{name}-core-tests-%{version}.jar
%{_javadir}/%{name}-core-tests.jar
%{_javadir}/%{name}-javac-%{version}.jar
%{_javadir}/%{name}-javac.jar
%{_javadir}/%{name}-eclipse-%{version}.jar
%{_javadir}/%{name}-eclipse.jar
%{_javadir}/%{name}-groovy-%{version}.jar
%{_javadir}/%{name}-groovy.jar
%{_javadir}/%{name}-janino-%{version}.jar
%{_javadir}/%{name}-janino.jar
%{_javadir}/%{name}-rhino-%{version}.jar
%{_javadir}/%{name}-rhino.jar
%{_javadir}/%{name}-examples-%{version}.jar
%{_javadir}/%{name}-examples.jar
%{_javadir}/%{short_name}-fam-%{version}.jar
%{_javadir}/%{short_name}-fam.jar
%{_javadir}/%{short_name}-core-%{version}.jar
%{_javadir}/%{short_name}-core.jar
%{_javadir}/%{short_name}-core-tests-%{version}.jar
%{_javadir}/%{short_name}-core-tests.jar
%{_javadir}/%{short_name}-javac-%{version}.jar
%{_javadir}/%{short_name}-javac.jar
%{_javadir}/%{short_name}-eclipse-%{version}.jar
%{_javadir}/%{short_name}-eclipse.jar
%{_javadir}/%{short_name}-groovy-%{version}.jar
%{_javadir}/%{short_name}-groovy.jar
%{_javadir}/%{short_name}-janino-%{version}.jar
%{_javadir}/%{short_name}-janino.jar
%{_javadir}/%{short_name}-rhino-%{version}.jar
%{_javadir}/%{short_name}-rhino.jar
%{_javadir}/%{short_name}-examples-%{version}.jar
%{_javadir}/%{short_name}-examples.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc LICENSE.txt NOTICE.txt README.txt TODO.txt

%files javadoc
%{_javadocdir}/%{short_name}


%changelog

* Thu Oct 27 2011 gil <gil> 1.1-1.mga2
+ Revision: 158837
- imported package apache-commons-jci

